<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

  <xsl:output method="xml" indent="yes"/>

  <xsl:template match="*|@*|text()|comment()|processing-instruction()">
    <xsl:copy>
      <xsl:apply-templates select="*|@*|text()|comment()|processing-instruction()"/>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="for-loop">
    <xsl:element name="xsl:call-template" namespace="http://www.w3.org/1999/XSL/Transform">
      <xsl:attribute name="name">for-loop</xsl:attribute>
      <xsl:element name="xsl:with-param" namespace="http://www.w3.org/1999/XSL/Transform">
        <xsl:attribute name="name">i</xsl:attribute>
        <xsl:attribute name="select">
          <xsl:value-of select="@index-variable"/>
        </xsl:attribute>
      </xsl:element>
      <xsl:element name="xsl:with-param" namespace="http://www.w3.org/1999/XSL/Transform">
        <xsl:attribute name="name">increment</xsl:attribute>
        <xsl:attribute name="select">
          <xsl:value-of select="@increment"/>
        </xsl:attribute>
      </xsl:element>
      <xsl:element name="xsl:with-param" namespace="http://www.w3.org/1999/XSL/Transform">
        <xsl:attribute name="name">operator</xsl:attribute>
        <xsl:attribute name="select">
          <xsl:text>'</xsl:text><xsl:value-of select="@operator"/><xsl:text>'</xsl:text>
        </xsl:attribute>
      </xsl:element>
      <xsl:element name="xsl:with-param" namespace="http://www.w3.org/1999/XSL/Transform">
        <xsl:attribute name="name">testValue</xsl:attribute>
        <xsl:attribute name="select">
          <xsl:value-of select="@test-value"/>
        </xsl:attribute>
      </xsl:element>
    </xsl:element>
  </xsl:template>

  <xsl:template match="for-loop" mode="generate-template">
    <xsl:element name="xsl:template" namespace="http://www.w3.org/1999/XSL/Transform">
      <xsl:attribute name="name">for-loop</xsl:attribute>
      <xsl:element name="xsl:param" namespace="http://www.w3.org/1999/XSL/Transform">
        <xsl:attribute name="name">i</xsl:attribute>
        <xsl:attribute name="select">
          <xsl:value-of select="@index-variable"/>
        </xsl:attribute>
      </xsl:element>
      <xsl:element name="xsl:param" namespace="http://www.w3.org/1999/XSL/Transform">
        <xsl:attribute name="name">increment</xsl:attribute>
        <xsl:attribute name="select">
          <xsl:value-of select="@increment"/>
        </xsl:attribute>
      </xsl:element>
      <xsl:element name="xsl:param" namespace="http://www.w3.org/1999/XSL/Transform">
        <xsl:attribute name="name">operator</xsl:attribute>
        <xsl:attribute name="select">
          <xsl:text>'</xsl:text><xsl:value-of select="@operator"/><xsl:text>'</xsl:text>
        </xsl:attribute>
      </xsl:element>
      <xsl:element name="xsl:param" namespace="http://www.w3.org/1999/XSL/Transform">
        <xsl:attribute name="name">testValue</xsl:attribute>
        <xsl:attribute name="select">
          <xsl:value-of select="@test-value"/>
        </xsl:attribute>
      </xsl:element>
      <xsl:element name="xsl:param" namespace="http://www.w3.org/1999/XSL/Transform">
        <xsl:attribute name="name">iteration</xsl:attribute>
        <xsl:attribute name="select">1</xsl:attribute>
      </xsl:element>

      <xsl:element name="xsl:variable" namespace="http://www.w3.org/1999/XSL/Transform">
        <xsl:attribute name="name">
          <xsl:text>testPassed</xsl:text>
        </xsl:attribute>
        <xsl:element name="xsl:choose" namespace="http://www.w3.org/1999/XSL/Transform">
          <xsl:element name="xsl:when" namespace="http://www.w3.org/1999/XSL/Transform">
            <xsl:attribute name="test">
              <xsl:text>starts-with($operator, '!=')</xsl:text>
            </xsl:attribute>
            <xsl:element name="xsl:if" namespace="http://www.w3.org/1999/XSL/Transform">
              <xsl:attribute name="test">
                <xsl:text>$i != $testValue</xsl:text>
              </xsl:attribute>
              <xsl:element name="xsl:text" namespace="http://www.w3.org/1999/XSL/Transform">
                <xsl:text>true</xsl:text>
              </xsl:element>
            </xsl:element>
          </xsl:element>
          <xsl:element name="xsl:when" namespace="http://www.w3.org/1999/XSL/Transform">
            <xsl:attribute name="test">
              <xsl:text>starts-with($operator, '&lt;=')</xsl:text>
            </xsl:attribute>
            <xsl:element name="xsl:if" namespace="http://www.w3.org/1999/XSL/Transform">
              <xsl:attribute name="test">
                <xsl:text>$i &lt;= $testValue</xsl:text>
              </xsl:attribute>
              <xsl:element name="xsl:text" namespace="http://www.w3.org/1999/XSL/Transform">
                <xsl:text>true</xsl:text>
              </xsl:element>
            </xsl:element>
          </xsl:element>
          <xsl:element name="xsl:when" namespace="http://www.w3.org/1999/XSL/Transform">
            <xsl:attribute name="test">
              <xsl:text>starts-with($operator, '&gt;=')</xsl:text>
            </xsl:attribute>
            <xsl:element name="xsl:if" namespace="http://www.w3.org/1999/XSL/Transform">
              <xsl:attribute name="test">
                <xsl:text>$i &gt;= $testValue</xsl:text>
              </xsl:attribute>
              <xsl:element name="xsl:text" namespace="http://www.w3.org/1999/XSL/Transform">
                <xsl:text>true</xsl:text>
              </xsl:element>
            </xsl:element>
          </xsl:element>
          <xsl:element name="xsl:when" namespace="http://www.w3.org/1999/XSL/Transform">
            <xsl:attribute name="test">
              <xsl:text>starts-with($operator, '=')</xsl:text>
            </xsl:attribute>
            <xsl:element name="xsl:if" namespace="http://www.w3.org/1999/XSL/Transform">
              <xsl:attribute name="test">
                <xsl:text>$i = $testValue</xsl:text>
              </xsl:attribute>
              <xsl:element name="xsl:text" namespace="http://www.w3.org/1999/XSL/Transform">
                <xsl:text>true</xsl:text>
              </xsl:element>
            </xsl:element>
          </xsl:element>
          <xsl:element name="xsl:when" namespace="http://www.w3.org/1999/XSL/Transform">
            <xsl:attribute name="test">
              <xsl:text>starts-with($operator, '&lt;')</xsl:text>
            </xsl:attribute>
            <xsl:element name="xsl:if" namespace="http://www.w3.org/1999/XSL/Transform">
              <xsl:attribute name="test">
                <xsl:text>$i &lt; $testValue</xsl:text>
              </xsl:attribute>
              <xsl:element name="xsl:text" namespace="http://www.w3.org/1999/XSL/Transform">
                <xsl:text>true</xsl:text>
              </xsl:element>
            </xsl:element>
          </xsl:element>
          <xsl:element name="xsl:when" namespace="http://www.w3.org/1999/XSL/Transform">
            <xsl:attribute name="test">
              <xsl:text>starts-with($operator, '&gt;')</xsl:text>
            </xsl:attribute>
            <xsl:element name="xsl:if" namespace="http://www.w3.org/1999/XSL/Transform">
              <xsl:attribute name="test">
                <xsl:text>$i &gt; $testValue</xsl:text>
              </xsl:attribute>
              <xsl:element name="xsl:text" namespace="http://www.w3.org/1999/XSL/Transform">
                <xsl:text>true</xsl:text>
              </xsl:element>
            </xsl:element>
          </xsl:element>
          <xsl:element name="xsl:otherwise" namespace="http://www.w3.org/1999/XSL/Transform">
            <xsl:element name="xsl:message" namespace="http://www.w3.org/1999/XSL/Transform">
              <xsl:attribute name="terminate">
                <xsl:text>yes</xsl:text>
              </xsl:attribute>
              <xsl:element name="xsl:text" namespace="http://www.w3.org/1999/XSL/Transform">
                <xsl:text>Sorry, the for-loop emulator only handles six operators </xsl:text>
              </xsl:element>
              <xsl:element name="xsl:text" namespace="http://www.w3.org/1999/XSL/Transform">
                <xsl:text>(&lt; | &gt; | = | &lt;= | &gt;= | !=).  The value </xsl:text>
              </xsl:element>
              <xsl:element name="xsl:value-of" namespace="http://www.w3.org/1999/XSL/Transform">
                <xsl:attribute name="select">
                  <xsl:text>$operator</xsl:text>
                </xsl:attribute>
              </xsl:element>
              <xsl:element name="xsl:text" namespace="http://www.w3.org/1999/XSL/Transform">
                <xsl:text> is not allowed.</xsl:text>
              </xsl:element>
            </xsl:element>
          </xsl:element>
        </xsl:element>
      </xsl:element>

      <xsl:element name="xsl:if" namespace="http://www.w3.org/1999/XSL/Transform">
        <xsl:attribute name="test">
          <xsl:text>$testPassed='true'</xsl:text>
        </xsl:attribute>
        <xsl:comment>
          <xsl:text>Here's the text from your original stylesheet:</xsl:text>
        </xsl:comment>

        <xsl:apply-templates select="*"/>

        <xsl:comment>
          <xsl:text>End of the section from your original stylesheet</xsl:text>
        </xsl:comment>

        <xsl:element name="xsl:call-template" namespace="http://www.w3.org/1999/XSL/Transform">
          <xsl:attribute name="name">for-loop</xsl:attribute>
          <xsl:element name="xsl:with-param" namespace="http://www.w3.org/1999/XSL/Transform">
            <xsl:attribute name="name">i</xsl:attribute>
            <xsl:attribute name="select">$i + $increment</xsl:attribute>
          </xsl:element>
          <xsl:element name="xsl:with-param" namespace="http://www.w3.org/1999/XSL/Transform">
            <xsl:attribute name="name">
              <xsl:text>increment</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="select">
              <xsl:text>$increment</xsl:text>
            </xsl:attribute>
          </xsl:element>
          <xsl:element name="xsl:with-param" namespace="http://www.w3.org/1999/XSL/Transform">
            <xsl:attribute name="name">
              <xsl:text>operator</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="select">
              <xsl:text>$operator</xsl:text>
            </xsl:attribute>
          </xsl:element>
          <xsl:element name="xsl:with-param" namespace="http://www.w3.org/1999/XSL/Transform">
            <xsl:attribute name="name">
              <xsl:text>testValue</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="select">
              <xsl:text>$testValue</xsl:text>
            </xsl:attribute>
          </xsl:element>
          <xsl:element name="xsl:with-param" namespace="http://www.w3.org/1999/XSL/Transform">
            <xsl:attribute name="name">
              <xsl:text>iteration</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="select">
              <xsl:text>$iteration + 1</xsl:text>
            </xsl:attribute>
          </xsl:element>
        </xsl:element>
      </xsl:element>
    </xsl:element>
  </xsl:template>

  <xsl:template match="/">
    <xsl:element name="stylesheet" namespace="http://www.w3.org/1999/XSL/Transform">
      <xsl:attribute name="version">1.0</xsl:attribute>
      <xsl:apply-templates select="//for-loop" mode="generate-template"/>
      <xsl:element name="xsl:template" namespace="http://www.w3.org/1999/XSL/Transform">
        <xsl:attribute name="match">/</xsl:attribute>
        <xsl:apply-templates select="*"/>
      </xsl:element>
    </xsl:element>
  </xsl:template>

</xsl:stylesheet>
