<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:states="http://new.usps.com/cgi-bin/uspsbv/scripts/content.jsp?D=10090">

  <states:name abbrev="AL">Alabama</states:name>
  <states:name abbrev="AL">Alabama</states:name>
  <states:name abbrev="AK">Alaska</states:name>
  <states:name abbrev="AS">American Samoa</states:name>
  <states:name abbrev="AZ">Arizona</states:name>
  <states:name abbrev="AR">Arkansas</states:name>
  <states:name abbrev="CA">California</states:name>
  <states:name abbrev="CO">Colorado</states:name>
  <states:name abbrev="CT">Connecticut</states:name>
  <states:name abbrev="DE">Delaware</states:name>
  <states:name abbrev="DC">District of Columbia</states:name>
  <states:name abbrev="FM">Federated States of Micronesia</states:name>
  <states:name abbrev="FL">Florida</states:name>
  <states:name abbrev="GA">Georgia</states:name>
  <states:name abbrev="GU">Guam</states:name>
  <states:name abbrev="HI">Hawaii</states:name>
  <states:name abbrev="ID">Idaho</states:name>
  <states:name abbrev="IL">Illinois</states:name>
  <states:name abbrev="IN">Indiana</states:name>
  <states:name abbrev="IA">Iowa</states:name>
  <states:name abbrev="KS">Kansas</states:name>
  <states:name abbrev="KY">Kentucky</states:name>
  <states:name abbrev="LA">Louisiana</states:name>
  <states:name abbrev="ME">Maine</states:name>
  <states:name abbrev="MH">Marshall Islands</states:name>
  <states:name abbrev="MD">Maryland</states:name>
  <states:name abbrev="MA">Massachusetts</states:name>
  <states:name abbrev="MI">Michigan</states:name>
  <states:name abbrev="MN">Minnesota</states:name>
  <states:name abbrev="MS">Mississippi</states:name>
  <states:name abbrev="MO">Missouri</states:name>
  <states:name abbrev="MT">Montana</states:name>
  <states:name abbrev="NE">Nebraska</states:name>
  <states:name abbrev="NV">Nevada</states:name>
  <states:name abbrev="NH">New Hampshire</states:name>
  <states:name abbrev="NJ">New Jersey</states:name>
  <states:name abbrev="NM">New Mexico</states:name>
  <states:name abbrev="NY">New York</states:name>
  <states:name abbrev="NC">North Carolina</states:name>
  <states:name abbrev="ND">North Dakota</states:name>
  <states:name abbrev="MP">Northern Mariana Islands</states:name>
  <states:name abbrev="OH">Ohio</states:name>
  <states:name abbrev="OK">Oklahoma</states:name>
  <states:name abbrev="OR">Oregon</states:name>
  <states:name abbrev="PW">Palau</states:name>
  <states:name abbrev="PA">Pennsylvania</states:name>
  <states:name abbrev="PR">Puerto Rico</states:name>
  <states:name abbrev="RI">Rhode Island</states:name>
  <states:name abbrev="SC">South Carolina</states:name>
  <states:name abbrev="SD">South Dakota</states:name>
  <states:name abbrev="TN">Tennessee</states:name>
  <states:name abbrev="TX">Texas</states:name>
  <states:name abbrev="UT">Utah</states:name>
  <states:name abbrev="VT">Vermont</states:name>
  <states:name abbrev="VI">Virgin Islands</states:name>
  <states:name abbrev="VA">Virginia</states:name>
  <states:name abbrev="WA">Washington</states:name>
  <states:name abbrev="WV">West Virginia</states:name>
  <states:name abbrev="WI">Wisconsin</states:name>
  <states:name abbrev="WY">Wyoming</states:name>

  <xsl:output method="html" indent="no"/>
  <xsl:strip-space elements="*"/>

  <xsl:template match="/">
    <html>
      <head>
        <title><xsl:value-of select="/report/title"/></title>
      </head>
      <body>
        <h3>Selected Purchase Orders - <i>Sorted by state</i></h3>
        <xsl:for-each select="document(/report/po/@filename)/purchase-order/customer/address/state">
          <xsl:sort select="document('')/*/states:name[@abbrev=current()]"/>
          <xsl:apply-templates select="ancestor::purchase-order"/>
        </xsl:for-each> 
      </body>
    </html>
  </xsl:template>

  <xsl:template match="purchase-order">
    <hr/>
    <h3>
      <xsl:value-of select="customer/address[@type='business']/name/title"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="customer/address[@type='business']/name/first-name"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="customer/address[@type='business']/name/last-name"/>
      <xsl:text> (</xsl:text>
      <xsl:value-of select="date/@month"/>
      <xsl:text>/</xsl:text>
      <xsl:value-of select="date/@day"/>
      <xsl:text>/</xsl:text>
      <xsl:value-of select="date/@year"/>
      <xsl:text>)</xsl:text>
    </h3>
    <table border="1" width="50%">
      <tr bgcolor="silver">
        <th>Shipped to:</th>
      </tr>
      <tr>
        <td>
          <xsl:choose>
            <xsl:when test="customer/address[@type='ship-to']/name">
              <xsl:apply-templates select="customer/address[@type='ship-to']"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:apply-templates select="customer/address[@type='business']"/>
            </xsl:otherwise>
          </xsl:choose>
        </td>
      </tr>
    </table>
    <br/>
    <table width="100%" border="0" cols="55% 15% 15% 15%">
      <tr bgcolor="lightgreen">
        <th>Item</th>
        <th>Quantity</th>
        <th>Price Each</th>
        <th>Total</th>
      </tr>
      <xsl:for-each select="items/item">
        <tr>
          <xsl:attribute name="bgcolor">
            <xsl:choose>
              <xsl:when test="position() mod 2">
                <xsl:text>white</xsl:text>
              </xsl:when>
              <xsl:otherwise>
                <xsl:text>lightgreen</xsl:text>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <td>
            <b><xsl:value-of select="name"/></b>
            <xsl:text> (part #</xsl:text>
            <xsl:value-of select="@part_no"/>
            <xsl:text>)</xsl:text>
          </td>
          <td align="center">
            <xsl:value-of select="qty"/>
          </td>
          <td align="right">
            <xsl:value-of select="price"/>
          </td>
          <td align="right">
            <xsl:choose>
              <xsl:when test="position()=1">
                <xsl:value-of select="format-number(price * qty, '$#,###.00')"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="format-number(price * qty, '#,###.00')"/>
              </xsl:otherwise>
            </xsl:choose>
          </td>
        </tr>
      </xsl:for-each>
      <tr>
        <td colspan="3" align="right">
          <b>Total for this order:</b>
        </td>
        <td align="right" bgcolor="silver">
          <xsl:variable name="orderTotal">
            <xsl:call-template name="sumItems">
              <xsl:with-param name="items" select="items"/>
              <xsl:with-param name="index" select="'1'"/>
              <xsl:with-param name="runningTotal" select="'0'"/>
            </xsl:call-template>
          </xsl:variable>
          <b><xsl:value-of select="format-number($orderTotal, '$#,###.00')"/></b>
        </td>
      </tr>
    </table>
  </xsl:template>

  <xsl:template match="address">
    <xsl:value-of select="name/title"/>
    <xsl:text> </xsl:text>
    <xsl:value-of select="name/first-name"/>
    <xsl:text> </xsl:text>
    <xsl:value-of select="name/last-name"/>
    <br />
    <xsl:value-of select="street"/>
    <br />
    <xsl:value-of select="city"/>
    <xsl:text>, </xsl:text>
    <b><xsl:value-of select="document('')/*/states:name[@abbrev=current()/state]"/></b>
    <xsl:text>  </xsl:text>
    <xsl:value-of select="zip"/>
  </xsl:template>

  <xsl:template name="sumItems">
    <xsl:param name="items"/>
    <xsl:param name="index" select="'1'"/>
    <xsl:param name="runningTotal" select="'0'"/>
    <xsl:variable name="currentItem">
      <xsl:value-of select="$items/item[$index]/qty * $items/item[$index]/price"/>
    </xsl:variable>
    <xsl:variable name="remainingItems">
      <xsl:choose>
        <xsl:when test="$index=count($items/item)">
          <xsl:text>0</xsl:text>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="sumItems">
            <xsl:with-param name="items" select="$items"/>
            <xsl:with-param name="index" select="$index+1"/>
            <xsl:with-param name="runningTotal" select="$runningTotal+$currentItem"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:value-of select="$currentItem+$remainingItems"/>
  </xsl:template>

</xsl:stylesheet>
