import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.Statement;
import org.apache.xalan.extensions.XSLProcessorContext;
import org.apache.xalan.templates.ElemExtensionCall;
import org.apache.xpath.DOMHelper;
import org.apache.xpath.objects.XNodeSet;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class DatabaseExtension 
{
  private static boolean getDriver(String driverName)
  {
    boolean gotTheDriver = false;
    try
    {
      Class.forName(driverName);
      gotTheDriver = true;
    }
    catch (Exception e)
    {
      System.out.println("Can't load the database driver " + driverName);
      e.printStackTrace();
    }
    return gotTheDriver;
  }

  public static XNodeSet accessDatabase(XSLProcessorContext context, 
                                        ElemExtensionCall elem)
  {
    XNodeSet dbResult = null;
    DOMHelper dh = new DOMHelper();
    Document doc = dh.getDOMFactory();
    Element table = null, header = null, tr = null, td = null, th = null;
    
    Element contextNode = (Element) context.getContextNode();
    if (getDriver(contextNode.getAttribute("driver")))
    {
      try
      {
        StringBuffer query = new StringBuffer("select ");
        query.append(contextNode.getAttribute("fieldnames") + " ");
        query.append("from " + contextNode.getAttribute("tablename") + " ");
        String nextAttr = contextNode.getAttribute("group-by");
        if (nextAttr != null)
          query.append(" group by " + nextAttr);
        nextAttr = contextNode.getAttribute("order-by");
        if (nextAttr != null)
          query.append(" order by " + nextAttr);

        Connection con = DriverManager.
          getConnection(contextNode.getAttribute("database"));
        Statement stmt = con.createStatement();
        ResultSet rs = stmt.executeQuery(query.toString());
        
        ResultSetMetaData rsmd = rs.getMetaData();
        int columnCount = rsmd.getColumnCount();
        table = doc.createElement("table");
        table.setAttribute("border", "1");

        header = doc.createElement("tr");
        for (int i = 1; i <= columnCount; i++)
        {
          th = doc.createElement("th");
          th.appendChild(doc.createTextNode(rsmd.getColumnName(i)));
          header.appendChild(th);
        }
        table.appendChild(header);
        
        while (rs.next())
        {
          tr = doc.createElement("tr");
          for (int i = 1; i <= columnCount; i++)
          {
            td = doc.createElement("td");
            td.appendChild(doc.createTextNode(rs.getString(i)));
            tr.appendChild(td);
          }
          table.appendChild(tr);
        }
        dbResult = new XNodeSet(table);
        rs.close();
        stmt.close();
        con.close();
      }
      catch (java.sql.SQLException sqle)
      {
        System.out.println("Exception: " + sqle);
      }
    }
    else
      System.out.println("Couldn't load the driver!");

    return dbResult;
  }
}
